﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="TreeGridSample.aspx.cs" Inherits="TreeGridSample.TreeGridSample" %>

<%--<%@ Register assembly="Syncfusion.EJ" namespace="Syncfusion.JavaScript.Models" tagprefix="ej" %>--%>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>TreeGrid Sample</title>
    <script src="Scripts/TreeGrid/jquery-1.10.2.min.js"></script>
    <script src="Scripts/TreeGrid/jquery.globalize.min.js"></script>
    <script src="Scripts/TreeGrid/jquery.easing.1.3.min.js"></script>
    <script src="Scripts/TreeGrid/jsrender.min.js"></script>
    <script src="Scripts/TreeGrid/ej.web.all.min.js"></script>
    <link href="Content/TreeGrid/ej.widgets.core.min.css" rel="stylesheet" />
    <link href="Content/TreeGrid/ej.theme.min.css" rel="stylesheet" />
    <style>
         #TreeGrid {
             width: 95%;
             height: 95%;             
         }
         html, body {
             overflow: hidden; padding:0; margin: 0;height:100%;position:static;
         }
     </style>
    
</head>
<body>
    <form id="form1" runat="server" onsubmit="return false" style="overflow: hidden; padding:0; margin: 0;height:100%;width:100%;">
        <ej:TreeGrid ID="TreeGrid" runat="server" AllowSelection="True"
             AllowSorting="True" AllowColumnResize="False"  EndEdit="endEdit"
             IdMapping="TaskId" ParentIdMapping="ParentId"
             ChildMapping="Children"
             TreeColumnIndex="1"  DataSourceID="SqlDataSource1" ActionComplete="ActionComplete">            
           <EditSettings AllowEditing="true" AllowAdding="true" AllowDeleting="true" EditMode="cellEditing" RowPosition="BelowSelectedRow" />
            <ToolbarSettings ShowToolbar="true" ToolbarItems="add,edit,delete,update,cancel,expandAll,collapseAll" />
            <Columns>
                <ej:TreeGridColumn HeaderText="Task Id" Field="TaskId" Width="45" />
                <ej:TreeGridColumn HeaderText="Task Name" Field="TaskName" />
                <ej:TreeGridColumn HeaderText="Start Date" Field="StartDate" />
                <ej:TreeGridColumn HeaderText="End Date" Field="EndDate" />
                <ej:TreeGridColumn HeaderText="Duration" Field="Duration" />
                <ej:TreeGridColumn HeaderText="Progress" Field="Progress" />
            </Columns>
        </ej:TreeGrid>
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:SelfReferenceConnectionString %>" 
            SelectCommand="SELECT * FROM [GanttData]"></asp:SqlDataSource>
            
        <asp:ScriptManager ID="ScriptManager" runat="server" EnablePageMethods="True" />

        
        <script type="text/javascript">
            
            function endEdit(args) {
                var editedRecord = args.data.item;
                //This varible holds the data of the edited record. You can updated it to your remote datasource
                PageMethods.UpdateIt(editedRecord);
            }

            function ActionComplete(args) {
                var record = args.data;
                if (args.requestType === 'addNewRow') {
                    //Newly Added Record is obtained here , which can be updated to database
                    addedRecord = args.addedRow;
                    PageMethods.AddIt(addedRecord);

                } else if (args.requestType === 'delete') {
                    var data = args.data;
                    var deletedRecord = data.item; //This is the deleted item. 
                    PageMethods.DeleteIt(deletedRecord);
                    //If deleted item has child records, we need to delete that too

                    if (data.hasChildRecords) {
                        deleteChildRecords(data);
                    }
                }

                    // To update the database during editing and update operation
                else if (args.requestType === 'recordUpdate') {
                    var item = args.data.item;
                    PageMethods.UpdateIt(item);
                }
            }

            //Delete inner level child records
            function deleteChildRecords(record) {
                var childRecords = record.childRecords,
                    length = childRecords.length,
                    count, currentRecord;
                for (count = 0; count < length; count++) {
                    currentRecord = childRecords[count];
                    var deletedChildRecord = currentRecord.item; //This is the deleted child item. 
                    //If the above deleted child record has child records, then we need to delete that too.
                    if (currentRecord.hasChildRecords) {
                        deleteChildRecords(currentRecord);
                    }
                }
            }
        </script>
    </form>
</body>
</html>
